# coding: utf-8

"""
    Logto API references

    API references for Logto services. To learn more about how to interact with Logto APIs, see [Interact with Management API](https://docs.logto.io/docs/recipes/interact-with-management-api/).

    The version of the OpenAPI document: Cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from py_logto.models.api_interaction_consent_get200_response_application_branding import ApiInteractionConsentGet200ResponseApplicationBranding
from py_logto.models.api_sign_in_exp_get200_response_mfa import ApiSignInExpGet200ResponseMfa
from py_logto.models.api_sign_in_exp_get200_response_password_policy import ApiSignInExpGet200ResponsePasswordPolicy
from py_logto.models.api_sign_in_exp_patch_request_color import ApiSignInExpPatchRequestColor
from py_logto.models.api_sign_in_exp_patch_request_language_info import ApiSignInExpPatchRequestLanguageInfo
from py_logto.models.api_sign_in_exp_patch_request_sign_in import ApiSignInExpPatchRequestSignIn
from py_logto.models.api_sign_in_exp_patch_request_sign_up import ApiSignInExpPatchRequestSignUp
from py_logto.models.api_sign_in_exp_patch_request_terms_of_use_url import ApiSignInExpPatchRequestTermsOfUseUrl
from typing import Optional, Set
from typing_extensions import Self

class ApiSignInExpPatchRequest(BaseModel):
    """
    ApiSignInExpPatchRequest
    """ # noqa: E501
    color: Optional[ApiSignInExpPatchRequestColor] = None
    branding: Optional[ApiInteractionConsentGet200ResponseApplicationBranding] = None
    language_info: Optional[ApiSignInExpPatchRequestLanguageInfo] = Field(default=None, alias="languageInfo")
    sign_in: Optional[ApiSignInExpPatchRequestSignIn] = Field(default=None, alias="signIn")
    sign_up: Optional[ApiSignInExpPatchRequestSignUp] = Field(default=None, alias="signUp")
    social_sign_in_connector_targets: Optional[List[StrictStr]] = Field(default=None, description="Specify the social sign-in connectors to display on the sign-in page.", alias="socialSignInConnectorTargets")
    sign_in_mode: Optional[StrictStr] = Field(default=None, alias="signInMode")
    custom_css: Optional[StrictStr] = Field(default=None, alias="customCss")
    custom_content: Optional[Dict[str, StrictStr]] = Field(default=None, description="Custom content to display on experience flow pages. the page pathname will be the config key, the content will be the config value.", alias="customContent")
    password_policy: Optional[ApiSignInExpGet200ResponsePasswordPolicy] = Field(default=None, alias="passwordPolicy")
    mfa: Optional[ApiSignInExpGet200ResponseMfa] = None
    single_sign_on_enabled: Optional[StrictBool] = Field(default=None, alias="singleSignOnEnabled")
    terms_of_use_url: Optional[ApiSignInExpPatchRequestTermsOfUseUrl] = Field(default=None, alias="termsOfUseUrl")
    privacy_policy_url: Optional[ApiSignInExpPatchRequestTermsOfUseUrl] = Field(default=None, alias="privacyPolicyUrl")
    __properties: ClassVar[List[str]] = ["color", "branding", "languageInfo", "signIn", "signUp", "socialSignInConnectorTargets", "signInMode", "customCss", "customContent", "passwordPolicy", "mfa", "singleSignOnEnabled", "termsOfUseUrl", "privacyPolicyUrl"]

    @field_validator('sign_in_mode')
    def sign_in_mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['SignIn', 'Register', 'SignInAndRegister']):
            raise ValueError("must be one of enum values ('SignIn', 'Register', 'SignInAndRegister')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiSignInExpPatchRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of color
        if self.color:
            _dict['color'] = self.color.to_dict()
        # override the default output from pydantic by calling `to_dict()` of branding
        if self.branding:
            _dict['branding'] = self.branding.to_dict()
        # override the default output from pydantic by calling `to_dict()` of language_info
        if self.language_info:
            _dict['languageInfo'] = self.language_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sign_in
        if self.sign_in:
            _dict['signIn'] = self.sign_in.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sign_up
        if self.sign_up:
            _dict['signUp'] = self.sign_up.to_dict()
        # override the default output from pydantic by calling `to_dict()` of password_policy
        if self.password_policy:
            _dict['passwordPolicy'] = self.password_policy.to_dict()
        # override the default output from pydantic by calling `to_dict()` of mfa
        if self.mfa:
            _dict['mfa'] = self.mfa.to_dict()
        # override the default output from pydantic by calling `to_dict()` of terms_of_use_url
        if self.terms_of_use_url:
            _dict['termsOfUseUrl'] = self.terms_of_use_url.to_dict()
        # override the default output from pydantic by calling `to_dict()` of privacy_policy_url
        if self.privacy_policy_url:
            _dict['privacyPolicyUrl'] = self.privacy_policy_url.to_dict()
        # set to None if custom_css (nullable) is None
        # and model_fields_set contains the field
        if self.custom_css is None and "custom_css" in self.model_fields_set:
            _dict['customCss'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiSignInExpPatchRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "color": ApiSignInExpPatchRequestColor.from_dict(obj["color"]) if obj.get("color") is not None else None,
            "branding": ApiInteractionConsentGet200ResponseApplicationBranding.from_dict(obj["branding"]) if obj.get("branding") is not None else None,
            "languageInfo": ApiSignInExpPatchRequestLanguageInfo.from_dict(obj["languageInfo"]) if obj.get("languageInfo") is not None else None,
            "signIn": ApiSignInExpPatchRequestSignIn.from_dict(obj["signIn"]) if obj.get("signIn") is not None else None,
            "signUp": ApiSignInExpPatchRequestSignUp.from_dict(obj["signUp"]) if obj.get("signUp") is not None else None,
            "socialSignInConnectorTargets": obj.get("socialSignInConnectorTargets"),
            "signInMode": obj.get("signInMode"),
            "customCss": obj.get("customCss"),
            "customContent": obj.get("customContent"),
            "passwordPolicy": ApiSignInExpGet200ResponsePasswordPolicy.from_dict(obj["passwordPolicy"]) if obj.get("passwordPolicy") is not None else None,
            "mfa": ApiSignInExpGet200ResponseMfa.from_dict(obj["mfa"]) if obj.get("mfa") is not None else None,
            "singleSignOnEnabled": obj.get("singleSignOnEnabled"),
            "termsOfUseUrl": ApiSignInExpPatchRequestTermsOfUseUrl.from_dict(obj["termsOfUseUrl"]) if obj.get("termsOfUseUrl") is not None else None,
            "privacyPolicyUrl": ApiSignInExpPatchRequestTermsOfUseUrl.from_dict(obj["privacyPolicyUrl"]) if obj.get("privacyPolicyUrl") is not None else None
        })
        return _obj


